// Indicator areas:
// Left  area: ONAIR, PREVIEW, TALK, DELAY; phone system status
// Right area: Show profile status and station logo
const keyPhoneNum=['0','1','2','3','4','5','6','7','8','9','*','#'];
const keyPhoneSip=['0','1','2','3','4','5','6','7','8','9','.','@'];
const keyPhoneTxt=['@0',':1','ABC2','DEF3','GHI4','JKL5','MNO6','PQRS7','TUV8','WXYZ9','()*','.,#'];
var gui_indi_show_loading=false;
var gui_indi=
{
	setOnAir: function(on) {this.onair.setIndex(on?1:0);},
	setPview: function(on) {this.pview.setIndex(on?1:0);},
	setTalk : function(on) {this.talk .setIndex(on?1:0);},
	setDelay: function(on) {this.delay.setIndex(on?1:0);},

	setShowName: function(name, loading)
	{
		this.show.setText(name);
		this.show.setProps({color: loading?color.red:color.yellow});
		gui_indi_show_loading=loading;
		if(gui_indi_show_loading)
			object_blinker.add(this.show, function(x) { return gui_indi_show_loading; }, true, null, null);
	},
	setShowChanged: function(on) {this.showChanged.setIndex(on?1:0);},

	setPhoneShowWaiting: function(on) {if(on) this.phShow.show(); else this.phShow.hide();},

/* ------ * In-Ring frame * ------ */
	inringOpen: function(id, number)
	{
		var ring=this.inring;

		ring.owner=id;
		ring.nr.setText(number);
		ring.show();
	},
	inringClose: function(id)
	{
		var ring=this.inring;
	
		if(ring.owner!=id) return;
		ring.owner=null;
		ring.hide();
	},
/* ------ * Dial-Out frame * ------ */
	numpadGrab: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=null)
		{
			if(pad.owner!=id)
			{
				if('onPadClose' in pad.owner)
					pad.owner.onPadClose();
			}
		}
		pad.owner=id;
	/* clear pad */
		pad.anto=host.clearTimeout(pad.anto);
		pad.moto=host.clearTimeout(pad.moto);
		if(pad.cnum!="")
		{
			pad.onum=pad.cnum;
			pad.cnum="";
		}
		pad.nr.setText(pad.cnum);
		pad.show();
	},
	numpadRelease: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=id) return;
		pad.owner=null;
		pad.hide();
	},
	numpadGetNumber: function(id)
	{
		var pad=this.numpad;

		if(pad.owner==null) return "";
		return pad.cnum;
	},
	numpadRecall: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=id) return;
		pad.cnum=pad.onum;
		pad.nr.setText(pad.cnum);
	},
/*
** gui_indi.numpadAppend
**
** appends key's symbol to dialout number
*/
	numpadAppend: function(key)
	{
		var pad=this.numpad;

	/* notify owner so it can play DTMF if it wish */
		if('onPadKey' in pad.owner) pad.owner.onPadKey(key);
	/* add number */
		if(pad.cnum.length<28)
		{
			if(pad.mode==0) /* Numeric Mode */
				pad.cnum+=keyPhoneNum[key];
			else if(pad.mode==1) /* SIP Mode */
				pad.cnum+=keyPhoneSip[key];
			else /* Alpha Numeric Mode */
			{
				if(pad.anto==null || pad.anlk!=key || pad.cnum.length==0)
					pad.cnum+=keyPhoneTxt[key].charAt(0);
				else
				{
					var wolast=pad.cnum.substr(0, pad.cnum.length-1);
					var last=pad.cnum.substr(pad.cnum.length-1, 1);
					var npos=(keyPhoneTxt[key].indexOf(last, 0)+1)%keyPhoneTxt[key].length;

					pad.cnum=wolast+keyPhoneTxt[key].charAt(npos);
				}
				pad.anlk=key;
				pad.anto=host.resetTimeout(pad.anto, 1000, function(){this.anto=null;}, pad);
			}
			pad.nr.setText(pad.cnum);
		}
	},
/*
** gui_indi.numpadEvent
**
** called when numpad key is pressed/released, returns true if handled
** key's are:
** 0-9: '0'-'9'
**  10: '*'
**  11: '#'
**  12: <backspace>
**  13: <enter>
*/
	numpadEvent: function(key, down)
	{
		var pad=this.numpad;
		var pos;

		if(pad.owner==null) return false;
		if(down)
		{
			if(key==12) /* backspace key */
			{
				if(pad.cnum.length>0)
				{
					pad.cnum=pad.cnum.substr(0, pad.cnum.length-1);
					pad.nr.setText(pad.cnum);
				}
				return true;
			}
			if(key==13)
			{
				if('onPadEnter' in pad.owner) pad.owner.onPadEnter();
				return true;
			}
		}
		if(!(key in keyPhoneNum)) return false;
		if(!down)
		{
			pad.anim.hide();
			if(key==11 && pad.moto!=null)
			{
				pad.moto=host.clearTimeout(pad.moto);
				if(pad.mode==0 && ('onPadEnter' in pad.owner)) /* # in numeric mode is enter */
					pad.owner.onPadEnter();
				else
					this.numpadAppend(key);
			}
			return true;
		}
	/* animate dialpad */
		pos=(key==0)?10:(key==11?key:key-1);
		pad.anim.moveTo(10+(pos%3)*4, 3+Math.floor(pos/3)*4);
		pad.anim.show();
		if(key==11) // '#' changes mode
		{
			pad.moto=host.resetTimeout(pad.moto, 1000, function(){this.moto=null;this.mode=(this.mode+1)%3;this.mi.setIndex(-1,this.mode);}, pad);
			return true;
		}
	/* add to number */
		this.numpadAppend(key);
		return true;
	}
};

/*
** Gui_CreateIndiSection
*/
function Gui_CreateIndiSection()
{
	var f, style;

// --- Left area:
	f=gui.newFrame(bgframe, 12, 535, 284, 238, "img/key_bg.png");

// standard indicators
	gui_indi.frmStd=gui.newFrame(f, 0, 0, 284, 238, '');
	gui_indi.onair=gui.newPicture(gui_indi.frmStd,  33, 48+(26+5)*0, 97, 26, "img/key_onair.png");
	gui_indi.pview=gui.newPicture(gui_indi.frmStd, 141, 48+(26+5)*0, 97, 26, "img/key_preview.png");
	gui_indi.talk =gui.newPicture(gui_indi.frmStd,  33, 48+(26+5)*1, 97, 26, "img/key_talk.png");
	gui_indi.delay=gui.newPicture(gui_indi.frmStd, 141, 48+(26+5)*1, 97, 26, "img/key_delay.png");

// phoneshow waiting notification
	gui_indi.phShow=gui.newLabel(f, 33, 169, 205, 26, '', {font:"myriad_pro_bi10", color:color.red, align:align.alignCenter});
	gui_indi.phShow.setText("New phone-show waiting...");
	gui_indi.phShow.hide();

// Numpad for Dialing
	style={font:"myriad_pro_9", color:color.yellow, align:align.alignLeft};
	gui_indi.numpad=gui.newFrame(gui_indi.frmStd, 33, 48+(26+5)*2, 205, 26, "img/dial-frame.png");
	gui_indi.numpad.mi=gui.newPicture(gui_indi.numpad, 11, 19, 11, 5, "img/dial-mode.png");
	gui_indi.numpad.nr=gui.newLabel(gui_indi.numpad, 26, 5, 170, 15, '', style);
	gui_indi.numpad.anim=gui.newPicture(gui_indi.numpad, 11, 5, 4, 4, "img/dial-anim.png");
	gui_indi.numpad.anim.hide();
	gui_indi.numpad.cnum="";
	gui_indi.numpad.onum="";
	gui_indi.numpad.anto=null;
	gui_indi.numpad.anlk=0;
	gui_indi.numpad.mode=0;
	gui_indi.numpad.moto=null;
	gui_indi.numpad.owner=null;
	gui_indi.numpad.hide();

// Incoming call Frame
	style={font:"myriad_pro_9", color:color.yellow, align:align.alignLeft};
	gui_indi.inring=gui.newFrame(gui_indi.frmStd, 33, 48+(26+5)*3, 205, 26, "img/ring-frame.png");
	gui_indi.inring.nr=gui.newLabel(gui_indi.inring, 26, 5, 170, 15, '', style);
	gui_indi.inring.owner=null;
	gui_indi.inring.hide();

// --- Right area:
	f=gui.newFrame(bgframe, 743, 535, 284, 238, "img/profile_bg.png");
// show indication
	gui_indi.show=gui.newLabel(f, 51, 56, 165, 24, '', {font:font.showTextsmall, color:color.yellow, align:align.alignCenter});
	gui_indi.show.setText(cur_show_name);
	gui_indi.showChanged=gui.newPicture(f, 186, 40, 12, 12, "img/led_blue.png");
// user logo
	gui_indi.logo=gui.newPicture(f, 70, 85, 129, 97, "*img/logo.png");
}
